﻿function pageLoad(sender, args) {
    // 显示更新提示面板
    showProgressBar(true);
    
    // 取得Feed集合
    RssService.GetRssEntries(onRssEntriesGot);
}

function onRssEntriesGot(result) {
    // 隐藏更新提示面板
    showProgressBar(false);
    
    // 构造Feed列表HTML字符串
    var listBuilder = new Sys.StringBuilder();
    for (var index = 0; index < result.length; ++index) {
        listBuilder.append("<li>");
        // 通过readFeed()函数得到Feed的详细内容
        listBuilder.append("<a href=\"javascript:readFeed(");
        listBuilder.append(result[index].Id); // Id
        listBuilder.append(")\" >");
        listBuilder.append(result[index].Title); // Title
        listBuilder.append("</a></li>");
    }
    
    // 设置到Feed列表元素上
    var feedList = $get("feedList");
    feedList.innerHTML = listBuilder.toString();
}

function readFeed(id) {
    // 显示更新提示面板
    showProgressBar(true);
    
    // 取得Feed的内容
    RssService.GetRssContent(id, onRssContentGot);
}

function onRssContentGot(result) {
    // 隐藏更新提示面板
    showProgressBar(false);
    
    // 构造Feed内容HTML字符串
    var contentBuilder = new Sys.StringBuilder();
    for (var index = 0; index < result.length; ++index) {
        contentBuilder.append("<h3><a href=\"");
        contentBuilder.append(result[index].Link); // Link
        contentBuilder.append("\" target=\"_blank\" >");
        contentBuilder.append(result[index].Title); // Title
        contentBuilder.append("</a></h3><div>");
        contentBuilder.append(result[index].Content); //Content
        contentBuilder.append("</div><hr />");
    }
    
    // 设置到Feed内容元素上
    var content = $get("content");
    content.innerHTML = contentBuilder.toString();
}

function btnAdd_onclick() {
    // 显示更新提示面板
    showProgressBar(true);
    
    // 添加新的Feed
    RssService.AddRssEntry($get("tbNewFeed").value, onRssEntryAdded);
}

function onRssEntryAdded(result) {
    // 隐藏更新提示面板
    showProgressBar(false);
    
    // 清空添加新Feed文本框
    $get("tbNewFeed").value = "";
    
    // 创建新的li元素
    var newFeedElem = document.createElement("li");
    
    // 构造li元素的HTML
    var newEntryBuilder = new Sys.StringBuilder();
    newEntryBuilder.append("<a href=\"javascript:readFeed(");
    newEntryBuilder.append(result.Id);
    newEntryBuilder.append(")\" >");
    newEntryBuilder.append(result.Title);
    newEntryBuilder.append("</a>");
    
    // 设置li元素的HTML
    newFeedElem.innerHTML = newEntryBuilder.toString();
    
    // 设置到li元素上
    var feedList = $get("feedList");
    feedList.appendChild(newFeedElem);
}

// 控制更新提示面板的显示与否
function showProgressBar(visible) {
    $get("progress").style.display = visible ? "block" : "none";
}

if(typeof(Sys)!=='undefined')Sys.Application.notifyScriptLoaded();