<%@ WebService Language="C#" Class="RssService" %>

using System;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Collections.Generic;
using System.Data;
using System.Net;

[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
[System.Web.Script.Services.ScriptService]
public class RssService : System.Web.Services.WebService
{
    private static List<RssEntry> rssEntryList;
    static RssService()
    {
        rssEntryList = new List<RssEntry>();
        rssEntryList.Add(RssEntry.CreateNew("ScottGu's Blog", 
            "http://weblogs.asp.net/scottgu/rss.aspx"));
        rssEntryList.Add(RssEntry.CreateNew("Brad Abrams", 
            "http://blogs.msdn.com/brada/rss.xml"));
        rssEntryList.Add(RssEntry.CreateNew("Nikhil Kothari's Weblog", 
            "http://www.nikhilk.net/Rss.ashx"));
        rssEntryList.Add(RssEntry.CreateNew("԰-ҳԭ.NET", 
            "http://www.cnblogs.com/rss.aspx"));
    }

    /// <summary>
    /// ȡǰеFeed
    /// </summary>
    /// <returns>Feed</returns>
    [WebMethod]
    public RssEntry[] GetRssEntries()
    {
        return rssEntryList.ToArray();
    }

    /// <summary>
    /// µFeed
    /// </summary>
    /// <param name="rssUrl">FeedURL</param>
    /// <returns>ɹӵFeed</returns>
    [WebMethod]
    public RssEntry AddRssEntry(string rssUrl)
    {
        // URLһRssFeed󣬲ȡϢ
        Rss.RssFeed feed = Rss.RssFeed.Read(rssUrl);

        // µRssEntry
        RssEntry newEntry = RssEntry.CreateNew(
            feed.Channels[0].Title, // 
            rssUrl // URL
        );

        // ӵ
        rssEntryList.Add(newEntry);

        return newEntry;
    }

    /// <summary>
    /// ָFeed
    /// </summary>
    /// <param name="id">Feedid</param>
    /// <returns>Feed</returns>
    [WebMethod]
    public ContentEntry[] GetRssContent(int id)
    {
        // IdõFeedURL
        string rssUrl = getUrlByRssEntryId(id);

        if (string.IsNullOrEmpty(rssUrl))
        {
            return null;
        }

        // URLһRssFeed󣬲ȡϢ
        Rss.RssFeed feed = Rss.RssFeed.Read(rssUrl);
        
        // FeedĿб
        List<ContentEntry> contentEntries = new List<ContentEntry>();
        
        for (int index = 0; index < feed.Channels[0].Items.Count; ++index)
        {
            ContentEntry contentEntry = new ContentEntry(
                feed.Channels[0].Items[index].Title, // 
                feed.Channels[0].Items[index].Link.AbsoluteUri, // URL
                feed.Channels[0].Items[index].Description // 
            );
            contentEntries.Add(contentEntry);
        }

        return contentEntries.ToArray();
    }

    /// <summary>
    /// IdõFeedURL
    /// </summary>
    /// <param name="id">FeedId</param>
    /// <returns>FeedURL</returns>
    private string getUrlByRssEntryId(int id)
    {
        foreach (RssEntry entry in rssEntryList)
        {
            if (entry.Id == id)
            {
                return entry.Url;
            }
        }
        return null;
    }
}

